Subject: draft-chisholm-disman-active-alarm-01.txt

From: "Sharon Chisholm" <[email-masked]>
Date: Mon, 23 Oct 2000 08:10:01 -0400

hi

Please accept draft-chisholm-disman-active-alarm-01.txt for
posting as an internet-draft.

This update contains alarm content in addition to the Active
Alarm list after feedback from Pittsburgh and the disman mailing
list.  Many thanks to Dan Romascanu for his review of a draft
version of this draft.

thanks,

Sharon

INTERNET-DRAFT                                          S. Chisholm
                                                        Nortel Networks
                                                        October 22 2000

                                Alarm MIB

Status of this Memo

This document is an Internet-Draft and is in full conformance with all
provisions of Section 10 of RFC2026.

Internet-Drafts are working documents of the Internet Engineering Task
Force (IETF), its areas, and its working groups.  Note that other groups
may also distribute working documents as Internet-Drafts.

Internet-Drafts are draft documents valid for a maximum of six months
and may be updated, replaced, or obsoleted by other documents at any
time.  It is inappropriate to use Internet- Drafts as reference material
or to cite them other than as "work in progress."

The list of current Internet-Drafts can be accessed at

http://www.ietf.org/ietf/1id-abstracts.txt

The list of Internet-Draft Shadow Directories can be accessed at
http://www.ietf.org/shadow.html.

1. Abstract

   This memo defines a portion of the Management Information Base (MIB)
   for use with network management protocols in the Internet community.
   In particular, it describes management objects used for maintaining
   a list of alarms currently active on a network element.

2.  The SNMP Management Framework

   The SNMP Management Framework presently consists of five major
   components:

    o   An overall architecture, described in RFC 2571 [RFC2571].

    o   Mechanisms for describing and naming objects and events for the
        purpose of management.  The first version of this Structure of
        Management Information (SMI) is called SMIv1 and described in
        STD 16, RFC 1155 [RFC1155], STD 16, RFC 1212 [RFC1212] and RFC

Expires 22 April 2001                                           [Page 1]

Internet Draft                 Alarm MIB                22 October 2000

        1215 [RFC1215].  The second version, called SMIv2, is described
        in STD 58, RFC 2578 [RFC2578], STD 58, RFC 2579 [RFC2579] and
        STD 58, RFC 2580 [RFC2580].

    o   Message protocols for transferring management information.  The
        first version of the SNMP message protocol is called SNMPv1 and
        described in STD 15, RFC 1157 [RFC1157].  A second version of
        the SNMP message protocol, which is not an Internet standards
        track protocol, is called SNMPv2c and described in RFC 1901
        [RFC1901] and RFC 1906 [RFC1906].  The third version of the
        message protocol is called SNMPv3 and described in RFC 1906
        [RFC1906], RFC 2572 [RFC2572] and RFC 2574 [RFC2574].

    o   Protocol operations for accessing management information.  The
        first set of protocol operations and associated PDU formats is
        described in STD 15, RFC 1157 [RFC1157].  A second set of
        protocol operations and associated PDU formats is described in
        RFC 1905 [RFC1905].

    o   A set of fundamental applications described in RFC 2573
        [RFC2573] and the view-based access control mechanism described
        in RFC 2575 [RFC2575].

   A more detailed introduction to the current SNMP Management Framework
   can be found in RFC 2570 [RFC2570].

   Managed objects are accessed via a virtual information store, termed
   the Management Information Base or MIB.  Objects in the MIB are
   defined using the mechanisms defined in the SMI.

   This memo specifies a MIB module that is compliant to the SMIv2.  A
   MIB conforming to the SMIv1 can be produced through the appropriate
   translations.  The resulting translated MIB must be semantically
   equivalent, except where objects or events are omitted because no
   translation is possible (use of Counter64).  Some machine readable
   information in SMIv2 will be converted into textual descriptions in
   SMIv1 during the translation process.  However, this loss of machine
   readable information is not considered to change the semantics of the
   MIB.

3. Introduction

   An alarm is an error condition occurring on a system that needs
   to be fixed, either automatically or through manual intervention.

   The alarm details table contains information which is applicable
   to all instances of an alarm.  It is populated at start-up with

Expires 22 April 2001                                           [Page 2]

Internet Draft                 Alarm MIB                22 October 2000

   all alarms that could happen on a system.  The information in this
   table should be fairly static during system operation.

   The active alarm table contains a list of alarms which are currently
   occurring on a system. It is intended that this table be queried
   upon device discovery and rediscovery to determine which alarms are
   currently active on the device. This allows the network management
   station to find out about any problems that may have occurred before
   it started managing a particular network element, or while it was out
   of contact with it.

   Each alarm should have a corresponding clear which removes it from
   the active alarm table. Alternatively it could be aged out.  The
   configuring and querying of alarm age-outs is not covered in this
   document.

4. Relation to Notification Log MIB

   This MIB is intended to compliment the notification log MIB, but
   can be used independently.  The active alarm table is defined in
   manner similar to that of the notification log table.  This format
   allows for the storage of any NOTIFICATION that can be defined using
   SMI.  Using the same format as the notification log MIB also
   simplifies operations for systems choosing to implement both MIBs.

5. Alarm Raise and Clear

   The alarm details table provides a means of defining the raise/clear
   relationship between alarms. The alarmDetailsPerceivedSeverity object
   indicates whether this is a raise alarm or a clear alarm. The
   alarmDetailsNotificationId gives the OID of this particular alarm. If
   this is a raise alarm, the alarmDetailsClearNotificationId object
   gives the OID of corresponding clear alarm.  If this is a clear
   alarm, the alarmDetailsClearNotificationId object gives the OID of
   one of the corresponding raise alarms for this clear.

6. ITU-T X.733, X.736 Trap Content

   Selected information from ITU-T X.733, X.736 alarm documents has been
   included in the alarmDetailsTable and the alarmActiveTable, depending
   on the variability of this information.  Support of these objects is
   not necessary to support the alarm raise/clear and active alarm
   components of this MIB.

Expires 22 April 2001                                           [Page 3]

Internet Draft                 Alarm MIB                22 October 2000

7. Definitions

ALARM-MIB DEFINITIONS ::= BEGIN

IMPORTS
    MODULE-IDENTITY, OBJECT-TYPE,
    experimental, Integer32, Unsigned32,
    TimeTicks, Counter32, Counter64,
    IpAddress, Opaque, mib-2            FROM SNMPv2-SMI
    TimeStamp, DateAndTime, DisplayString,
    StorageType, RowStatus              FROM SNMPv2-TC
    SnmpAdminString, SnmpEngineID       FROM SNMP-FRAMEWORK-MIB
    MODULE-COMPLIANCE, OBJECT-GROUP     FROM SNMPv2-CONF;

   alarm MODULE-IDENTITY
       LAST-UPDATED "000010220000Z"
       ORGANIZATION "Alarm MIB"
       CONTACT-INFO
               "   Sharon Chisholm
                   Nortel Networks
                   PO Box 3511 Station C
                   Ottawa, Ont.  K1Y 4H7
                   Canada

                   [email-masked]"
       DESCRIPTION
               "The MIB module describes a generic solution
               to improve the reliability of SNMP traps by storing alarm
               details and the current list of active alarms."
       ::= { mib-2 xx }

alarmObjects OBJECT IDENTIFIER ::= { alarm 1 }

alarmDetailsTable OBJECT-TYPE
    SYNTAX      SEQUENCE OF AlarmDetailsEntry
    MAX-ACCESS  not-accessible
    STATUS      current
    DESCRIPTION
        "A table of information about possible alarms on the system."
    ::= { alarmObjects 1 }

alarmDetailsEntry OBJECT-TYPE
    SYNTAX      AlarmDetailsEntry
    MAX-ACCESS  not-accessible
    STATUS      current
    DESCRIPTION
        "Entries appear in this table for each possible alarm."

Expires 22 April 2001                                           [Page 4]

Internet Draft                 Alarm MIB                22 October 2000

    INDEX       { alarmListName, alarmDetailsIndex }
    ::= { alarmDetailsTable 1 }

AlarmDetailsEntry ::= SEQUENCE {
    alarmDetailsIndex                 Unsigned32,
    alarmDetailsNotificationId        OBJECT IDENTIFIER,
    alarmDetailsClearNotificationId   OBJECT IDENTIFIER,
    alarmDetailsEventType             INTEGER,
    alarmDetailsProbableCause         INTEGER,
    alarmDetailsPerceivedSeverity     INTEGER,
    alarmDetailsAdditionalText        DisplayString }

alarmDetailsIndex OBJECT-TYPE
    SYNTAX     Unsigned32 (1..4294967295)
    MAX-ACCESS read-only
    STATUS     current
    DESCRIPTION
        "A integer which acts as the
        index of entries within the named alarm list. "
    ::= { alarmDetailsEntry 1 }

alarmDetailsNotificationId OBJECT-TYPE
    SYNTAX      OBJECT IDENTIFIER
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The NOTIFICATION-TYPE object identifier of this alarm."
    ::= { alarmDetailsEntry 2 }

alarmDetailsClearNotificationId OBJECT-TYPE
    SYNTAX      OBJECT IDENTIFIER
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The NOTIFICATION-TYPE object identifier of the alarm which
         clears this alarm. If this entry corresponds to a clear
         alarm, then this object should be one of the notifications
         which sets this alarm condition"
    ::= { alarmDetailsEntry 3 }

alarmDetailsEventType OBJECT-TYPE
    SYNTAX              INTEGER
            {
            other (1),
            communityAlarmType (2),
            qualityOfServerAlarmType (3),
            processingErrorAlarmType (4),

Expires 22 April 2001                                           [Page 5]

Internet Draft                 Alarm MIB                22 October 2000

            equipmentAlarmType (5),
            environmentalAlarmType (6)                         }
    MAX-ACCESS   read-only
    STATUS       current
    DESCRIPTION
             " Represents the event type values for the alarms as per
               (ITU-T X.733)."
     ::= { alarmDetailsEntry 4 }

alarmDetailsProbableCause OBJECT-TYPE
      SYNTAX         INTEGER
                       {
                        other (1),
                        adapterError (2),
                        applicationSubsystemFailure (3),
                        bandwidthReduced (4),
                        callEstablishmentError (5),
                        communicationsProtocolError (6),
                        communicationsSubsystemFailure (7),
                        configurationOrCustomizationError (8),
                        congestion (9),
                        corruptData (10),
                        cpuCyclesLimitExceeded (11),
                        dataSetOrModemError (12),
                        degradedSignal (13),
                        dteDceInterfaceError (14),
                        enclosureDoorOpen (15),
                        equipmentMalfunction (16),
                        excessiveVibration (17),
                        fileError (18),
                        fireDetected (19),
                        floodDetected (20),
                        framingError (21),
                        heatingOrVentilationOrCoolingSystemProblem (22),
                        humidityUnacceptable (23),
                        inputOutputDeviceError (24),
                        inputDeviceError (25),
                        lanError (26),
                        leakDetected (27),
                        localNodeTransmissionError (28),
                        lossOfFrame (29),
                        lossOfSignal (30),
                        materialSupplyExhausted (31),
                        multiplexerProblem (32),
                        outOfMemory (33),
                        ouputDeviceError (34),
                        performanceDegraded (35),
                        powerProblem (36),

Expires 22 April 2001                                           [Page 6]

Internet Draft                 Alarm MIB                22 October 2000

                        pressureUnacceptable (37),
                        processorProblem (38),
                        pumpFailure (39),
                        queueSizeExceeded (40),
                        receiveFailure (41),
                        receiverFailure (42),
                        remoteNodeTransmissionError (43),
                        resourceAtOrNearingCapacity (44),
                        responseTimeExecessive (45),
                        retransmissionRateExcessive (46),
                        softwareError (47),
                        softwareProgramAbnormallyTerminated (48),
                        softwareProgramError (49),
                        storageCapacityProblem (50),
                        temperatureUnacceptable (51),
                        thresholdCrossed (52),
                        timingProblem (53),
                        toxicLeakDetected (54),
                        transmitFailure (55),
                        transmitterFailure (56),
                        underlyingResourceUnavailable (57),
                        versionMismatch (58),
                        authenticationFailure (59),
                        breachOfConfidentiality (60),
                        cableTamper (61),
                        delayedInformation (62),
                        denialOfService (63),
                        duplicateInformation (64),
                        informationMissing (65),
                        informationModificationDetected (66),
                        informationOutOfSequence (67),
                        intrusionDetection (68),
                        keyExpired (69),
                        nonRepudiationFailure (70),
                        outOfHoursActivity (71),
                        outOfService (72),
                        proceduralError (73),
                        unauthorizedAccessAttempt (74),
                        unexpectedInformation (75)
                       }
    MAX-ACCESS  read-only
    STATUS       current

     DESCRIPTION
             " Represents the probable cause values for the alarms as
             per (ITU-T X.733, X.736)."
     ::= { alarmDetailsEntry 5 }

Expires 22 April 2001                                           [Page 7]

Internet Draft                 Alarm MIB                22 October 2000

alarmDetailsPerceivedSeverity OBJECT-TYPE
        SYNTAX          INTEGER                         {
            cleared (1),
            indeterminate (2),
            critical (3),
            major (4),
            minor (5),
            warning (6)                         }
    MAX-ACCESS  read-only
    STATUS       current
    DESCRIPTION
             " Represents the perceived severity values for the alarms
              as per (ITU-T X.733)."
     ::= { alarmDetailsEntry 6 }

alarmDetailsAdditionalText OBJECT-TYPE
        SYNTAX DisplayString
        MAX-ACCESS read-only
        STATUS     current
        DESCRIPTION
             " Represents the additional text field for the alarm as per
               (ITU-T X.733)."
         ::= { alarmDetailsEntry 7}

-- -- Active Alarm Table --

alarmActiveTable OBJECT-TYPE
    SYNTAX      SEQUENCE OF AlarmActiveEntry
    MAX-ACCESS  not-accessible
    STATUS      current
    DESCRIPTION
        "A table of Active Alarms entries."
    ::= { alarmObjects 2 }

alarmActiveEntry OBJECT-TYPE
    SYNTAX      AlarmActiveEntry
    MAX-ACCESS  not-accessible
    STATUS      current
    DESCRIPTION
        "Entries appear in this table when alarms are active.  They are
        removed when the alarm is no longer occurring."
    INDEX       { alarmListName, alarmActiveIndex }
    ::= { alarmActiveTable 1 }

AlarmActiveEntry ::= SEQUENCE {
    alarmListName                    SnmpAdminString,
    alarmActiveIndex                 Unsigned32,

Expires 22 April 2001                                           [Page 8]

Internet Draft                 Alarm MIB                22 October 2000

    alarmActiveTime                  TimeStamp,
    alarmActiveDateAndTime           DateAndTime,
    alarmActiveEngineID              SnmpEngineID,
    alarmActiveEngineAddress         IpAddress,
    alarmActiveContextEngineID       SnmpEngineID,
    alarmActiveContextName           SnmpAdminString,
    alarmActiveVariables             Unsigned32,
    alarmActiveNotificationID        OBJECT IDENTIFIER,
    alarmActiveTrendIndication       INTEGER,
    alarmActiveLogIndex              Unsigned32,
    alarmActiveDetailsIndex          Unsigned32 }

alarmListName OBJECT-TYPE
    SYNTAX     SnmpAdminString (SIZE(0..32))
    MAX-ACCESS not-accessible
    STATUS     current
    DESCRIPTION
     "The name of the list of alarms.  This is the same as
     nlmLogName if the Nofication Log MIB is supported.

     An implementation may allow multiple named alarm lists, up to
     some implementation-specific limit (which may be none).  A
     zero-length list name is reserved for creation and deletion
     by the managed system, and MUST be used as the default log
     name by systems that do not support named alarm lists."
    ::= { alarmActiveEntry 1 }

alarmActiveIndex OBJECT-TYPE
    SYNTAX     Unsigned32 (1..4294967295)
    MAX-ACCESS read-only
    STATUS     current
    DESCRIPTION
        "A monotonically increasing integer which acts as the
        index of entries within the named alarm list.  It wraps
        back to 1 after it reaches its maximum value."
    ::= { alarmActiveEntry 2 }

alarmActiveTime OBJECT-TYPE
    SYNTAX      TimeStamp
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value of sysUpTime when the alarm occurred. Alarms tend
        to get cleared and resent if still applicable at reboot, so this
        value tends to be is a valid sysUptime. In the case where the
        alarms are not cleared at reboot, and the alarm occurred before
        the most recent management system initialization, this object
        value MUST be set to zero."

Expires 22 April 2001                                           [Page 9]

Internet Draft                 Alarm MIB                22 October 2000

    ::= { alarmActiveEntry 3 }

alarmActiveDateAndTime OBJECT-TYPE
    SYNTAX      DateAndTime
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The local date and time when the alarm occurred, instantiated
        only by systems that have date and time capability."
    ::= { alarmActiveEntry 4 }

alarmActiveEngineID OBJECT-TYPE
    SYNTAX      SnmpEngineID
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The identification of the SNMP engine at which the alarm
        originated.
        If the alarm list can contain Notifications from only one
        engine or the Trap is from an SNMPv1 system, this object is not
        instantiated."
    ::= { alarmActiveEntry 5 }

alarmActiveEngineAddress OBJECT-TYPE
    SYNTAX      IpAddress
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
     "The IP Address of the SNMP engine on which the alarm is
     occurring. This is used to identify the source of an SNMPv1
     trap, since an alarmActiveEngineId cannot be extracted from the
     SNMPv1 trap pdu.

     This object MUST always be instantiated, even if the list
     can contain alarms from only one engine."
    ::= { alarmActiveEntry 6 }

alarmActiveContextEngineID OBJECT-TYPE
    SYNTAX      SnmpEngineID
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
     "If the alarm is occurring on a device using a protocol which
     has a contextEngineID element like SNMPv3, this object has that
     value. Otherwise its value is a zero-length string."
    ::= { alarmActiveEntry 7 }

Expires 22 April 2001                                          [Page 10]

Internet Draft                 Alarm MIB                22 October 2000

alarmActiveContextName OBJECT-TYPE
    SYNTAX      SnmpAdminString
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The name of the SNMP MIB context from which the alarm came.
        For SNMPv1 Traps this is the community string from the Trap.
        If the alarm's source SNMP engine is known not to support
        multiple contexts, this object is not instantiated."
    ::= { alarmActiveEntry 8 }

alarmActiveVariables OBJECT-TYPE
    SYNTAX      Unsigned32
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The number of variables in alarmActiveVariableTable for this
        Notification."
    ::= { alarmActiveEntry 9 }

alarmActiveNotificationID OBJECT-TYPE
    SYNTAX      OBJECT IDENTIFIER
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The NOTIFICATION-TYPE object identifier of the Notification
        that occurred."
    ::= { alarmActiveEntry 10 }

alarmActiveTrendIndication OBJECT-TYPE
    SYNTAX              INTEGER
       {
       moreSevere (1),
       noChange (2),
       lessSevere (3)
       }
    MAX-ACCESS  read-only
    STATUS       current
    DESCRIPTION
             " Represents the trend indication values for the alarms
             as per (ITU-T X.733)."
     ::= { alarmActiveEntry 11 }

alarmActiveLogIndex OBJECT-TYPE
    SYNTAX     Unsigned32 (0..4294967295)
    MAX-ACCESS read-only

Expires 22 April 2001                                          [Page 11]

Internet Draft                 Alarm MIB                22 October 2000

    STATUS     current
    DESCRIPTION
        "This number can be considered a sequence number for the trap.
        It should be the same as the log index in the notification log
        MIB, if used.  If no log index or sequence number applies to the
        trap, then this object should have the value of 0."
    ::= { alarmActiveEntry 12 }

alarmActiveDetailsIndex OBJECT-TYPE
    SYNTAX     Unsigned32 (0..4294967295)
    MAX-ACCESS read-only
    STATUS     current
    DESCRIPTION
        "The index of the corresponding row in the alarmDetails table.
        If the alarmDetails table is not supported this object should
        have a value of 0."
    ::= { alarmActiveEntry 13 }

-- -- Active Alarm Variable Table --

alarmActiveVariableTable OBJECT-TYPE
    SYNTAX      SEQUENCE OF AlarmActiveVariableEntry
    MAX-ACCESS  not-accessible
    STATUS      current
    DESCRIPTION
        "A table of variables to go with active alarm entries."
    ::= { alarmObjects 3 }

alarmActiveVariableEntry OBJECT-TYPE
    SYNTAX      AlarmActiveVariableEntry
    MAX-ACCESS  not-accessible
    STATUS      current
    DESCRIPTION
        "Entries appear in this table when there are variables in
        the varbind list of a corresponding alarm in alarmActiveTable."
    INDEX   {  alarmListName, alarmActiveIndex, alarmActiveVariableIndex
}
    ::= { alarmActiveVariableTable 1 }

AlarmActiveVariableEntry ::= SEQUENCE {
    alarmActiveVariableIndex                 Unsigned32,
    alarmActiveVariableID                    OBJECT IDENTIFIER,
    alarmActiveVariableValueType             INTEGER,
    alarmActiveVariableCounter32Val          Counter32,
    alarmActiveVariableUnsigned32Val         Unsigned32,
    alarmActiveVariableTimeTicksVal          TimeTicks,
    alarmActiveVariableInteger32Val          Integer32,
    alarmActiveVariableOctetStringVal        OCTET STRING,

Expires 22 April 2001                                          [Page 12]

Internet Draft                 Alarm MIB                22 October 2000

    alarmActiveVariableIpAddressVal          IpAddress,
    alarmActiveVariableOidVal                OBJECT IDENTIFIER,
    alarmActiveVariableCounter64Val          Counter64,
    alarmActiveVariableOpaqueVal             Opaque }

alarmActiveVariableIndex OBJECT-TYPE
    SYNTAX     Unsigned32 (1..4294967295)
    MAX-ACCESS not-accessible
    STATUS     current
    DESCRIPTION
        "A monotonically increasing integer, starting at 1 for a given
        alarmActiveIndex, for indexing variables within the active
        alarm list."
    ::= { alarmActiveVariableEntry 1 }

alarmActiveVariableID OBJECT-TYPE
    SYNTAX     OBJECT IDENTIFIER
    MAX-ACCESS read-only
    STATUS     current
    DESCRIPTION
        "The variable's object identifier."
    ::= { alarmActiveVariableEntry 2 }

alarmActiveVariableValueType OBJECT-TYPE
    SYNTAX      INTEGER { counter32(1), unsigned32(2), timeTicks(3),
                          integer32(4), ipAddress(5), octetString(6),
                          objectId(7), counter64(8), opaque(9) }
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The type of the value.  One and only one of the value
        objects that follow is used, based on this type."
    ::= { alarmActiveVariableEntry 3 }

alarmActiveVariableCounter32Val OBJECT-TYPE
    SYNTAX      Counter32
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'counter32'."
    ::= { alarmActiveVariableEntry 4 }

alarmActiveVariableUnsigned32Val OBJECT-TYPE
    SYNTAX      Unsigned32
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'unsigned32'."

Expires 22 April 2001                                          [Page 13]

Internet Draft                 Alarm MIB                22 October 2000

    ::= { alarmActiveVariableEntry 5 }

alarmActiveVariableTimeTicksVal OBJECT-TYPE
    SYNTAX      TimeTicks
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'timeTicks'."
    ::= { alarmActiveVariableEntry 6 }

alarmActiveVariableInteger32Val OBJECT-TYPE
    SYNTAX      Integer32
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'integer32'."
    ::= { alarmActiveVariableEntry 7 }

alarmActiveVariableOctetStringVal OBJECT-TYPE
    SYNTAX      OCTET STRING
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'octetString'."
    ::= { alarmActiveVariableEntry 8 }

alarmActiveVariableIpAddressVal OBJECT-TYPE
    SYNTAX      IpAddress
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'ipAddress'."
    ::= { alarmActiveVariableEntry 9 }

alarmActiveVariableOidVal OBJECT-TYPE
    SYNTAX      OBJECT IDENTIFIER
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'objectId'."
    ::= { alarmActiveVariableEntry 10 }

alarmActiveVariableCounter64Val OBJECT-TYPE
    SYNTAX      Counter64
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'counter64'."

Expires 22 April 2001                                          [Page 14]

Internet Draft                 Alarm MIB                22 October 2000

    ::= { alarmActiveVariableEntry 11 }

alarmActiveVariableOpaqueVal OBJECT-TYPE
    SYNTAX      Opaque
    MAX-ACCESS  read-only
    STATUS      current
    DESCRIPTION
        "The value when alarmActiveVariableType is 'opaque'."
    ::= { alarmActiveVariableEntry 12 }

-- -- Statistics --

alarmActiveStatsTable  OBJECT-TYPE
       SYNTAX  SEQUENCE OF AlarmActiveStatsEntry
       MAX-ACCESS  not-accessible
       STATUS  current
       DESCRIPTION
          "This table represents the alarm statistics type
          information."
        ::= { alarmObjects 4 }

   alarmActiveStatsEntry OBJECT-TYPE
       SYNTAX  AlarmActiveStatsEntry
       MAX-ACCESS  not-accessible
       STATUS  current
       DESCRIPTION
          "Statistics on the current active alarms."

       INDEX   { alarmListName }

        ::= {  alarmActiveStatsTable 1 }

   AlarmActiveStatsEntry ::=
       SEQUENCE {
            alarmActiveStatsTotalActive    Unsigned32
                 }

  alarmActiveStatsTotalActive OBJECT-TYPE
       SYNTAX Unsigned32
       MAX-ACCESS read-only
       STATUS  current
       DESCRIPTION
          "The total number of currently active alarms on the system."

Expires 22 April 2001                                          [Page 15]

Internet Draft                 Alarm MIB                22 October 2000

        ::= { alarmActiveStatsEntry 1 }

     -- Conformance Stuff

     alarmConformance OBJECT IDENTIFIER ::= { alarm 2 }

     alarmDetailsGroup OBJECT-GROUP
          OBJECTS {
            alarmDetailsIndex,
                alarmDetailsNotificationId,
                alarmDetailsClearNotificationId,
                alarmDetailsEventType,
                alarmDetailsProbableCause,
                alarmDetailsPerceivedSeverity,
                alarmDetailsAdditionalText
          }
        STATUS   current
        DESCRIPTION
                "Alarm details list group."
           ::= { alarmConformance 2}

         alarmActiveListGroup OBJECT-GROUP                   OBJECTS {
                    alarmListName,
                alarmActiveIndex,
                alarmActiveTime,
                alarmActiveDateAndTime,
                alarmActiveEngineID,
                alarmActiveEngineAddress,
                alarmActiveContextEngineID,
                alarmActiveContextName,
                alarmActiveVariables,
                alarmActiveNotificationID,
                alarmActiveLogIndex,
                alarmActiveVariableIndex,
                alarmActiveVariableID,
                alarmActiveVariableValueType,
                alarmActiveVariableCounter32Val,
                alarmActiveVariableUnsigned32Val,
                alarmActiveVariableTimeTicksVal,
                alarmActiveVariableInteger32Val,
                alarmActiveVariableOctetStringVal,
                alarmActiveVariableIpAddressVal,
                alarmActiveVariableOidVal,
                alarmActiveVariableCounter64Val,
                alarmActiveVariableOpaqueVal

Expires 22 April 2001                                          [Page 16]

Internet Draft                 Alarm MIB                22 October 2000

                }                    STATUS   current
           DESCRIPTION
                "Active Alarm list group."
           ::= { alarmConformance 3}

     alarmActiveSummaryGroup  OBJECT-GROUP
           OBJECTS  {
                    alarmActiveStatsTotalActive
                     }
           STATUS   current
           DESCRIPTION
                " Active alarm summary group."
           ::= { alarmConformance 4}

alarmCompliance MODULE-COMPLIANCE
       STATUS  current
       DESCRIPTION
           "The compliance statement for systems supporting
           the Alarm MIB."
       MODULE -- this module
           MANDATORY-GROUPS {
            alarmActiveListGroup
           }
           GROUP alarmActiveSummaryGroup
           DESCRIPTION
           "The actual active alarms."

        ::= { alarmConformance 1 }          END

8. Example

        Define the following Object:
          acmeWidgetIndex OBJECT-TYPE
            SYNTAX  Integer32
            MAX-ACCESS read-only
            STATUS   current
            DESCRIPTION
              "A unique number which identifies a particular Widget."
          ::= { acmeWidgetEntry 1 }

        Define the following three traps:
          acmeWidgetTemperatureCritical NOTIFICATION-TYPE
            OBJECTS { acmeWidgetIndex }
            STATUS      current
            DESCRIPTION
              "This trap indicates that the indicated

Expires 22 April 2001                                          [Page 17]

Internet Draft                 Alarm MIB                22 October 2000

                widget has reached a critical temperature."
          ::= { acmeWidgetTraps 1 }

          acmeWidgetTemperatureNormal NOTIFICATION-TYPE
            OBJECTS { acmeWidgetIndex }
            STATUS      current
            DESCRIPTION
              "This trap indicates that the indicated widget has
                reached a normal temperature."
          ::= { acmeWidgetTraps 2 }

          bgpBackwardTransition NOTIFICATION-TYPE
            OBJECTS { bgpPeerLastError,
                      bgpPeerState      }
            STATUS  current
            DESCRIPTION
               "The BGPBackwardTransition Event is generated
               when the BGP FSM moves from a higher numbered
               state to a lower numbered state."
           ::= { bgpTraps 2 }

        0. Active alarm table empty and nothing in notification log
                 ___________________________      _____________________
                | alarmActiveTable          |    | nlmLogTable         |
                |---------------------------|    |---------------------|
                | alarmActiveIndex |  alarm |    | nlmLogIndex | alarm |
                |---------------------------|    |---------------------|
                |___________________________|    |_____________________|

        1. Temperature of widget 2 goes critical
                 __________________________________________________
                | alarmActiveTable                                 |
                |--------------------------------------------------|
                | alarmActiveIndex |  alarm                        |
                |--------------------------------------------------|
                |        1         | acmeWidgetTemperatureCritical |
                |__________________________________________________|

                 _____________________________________________
                | nlmLogTable                                 |
                |---------------------------------------------|
                | nlmLogIndex |  alarm                        |
                |---------------------------------------------|
                |      1      | acmeWidgetTemperatureCritical |
                |_____________________________________________|

        2. BGP peering session transitions from a state of established

Expires 22 April 2001                                          [Page 18]

Internet Draft                 Alarm MIB                22 October 2000

           to opensent
                 __________________________________________________
                | alarmActiveTable                                 |
                |--------------------------------------------------|
                | alarmActiveIndex |  alarm                        |
                |--------------------------------------------------|
                |        1         | acmeWidgetTemperatureCritical |
                |        2         | bgpBackwardTransition         |
                |__________________________________________________|

                 _____________________________________________
                | nlmLogTable                                 |
                |---------------------------------------------|
                | nlmLogIndex |  alarm                        |
                |---------------------------------------------|
                |      1      | acmeWidgetTemperatureCritical |
                |      2      | bgpBackwardTransition         |
                |_____________________________________________|

        3. Temperature of widget 2 goes back to normal
                 __________________________________________________
                | alarmActiveTable                                 |
                |--------------------------------------------------|
                | alarmActiveIndex |  alarm                        |
                |--------------------------------------------------|
                |        2         | bgpBackwardTransition         |
                |__________________________________________________|

                 _____________________________________________
                | nlmLogTable                                 |
                |---------------------------------------------|
                | nlmLogIndex |  alarm                        |
                |---------------------------------------------|
                |      1      | acmeWidgetTemperatureCritical |
                |      2      | bgpBackwardTransition         |
                |      3      | acmeWidgetTemperatureNormal   |
                |_____________________________________________|

        4. Time passes .... BGP alarm ages out.

                 __________________________________________________
                | alarmActiveTable                                 |
                |--------------------------------------------------|
                | alarmActiveIndex |  alarm                        |
                |--------------------------------------------------|
                |__________________________________________________|

Expires 22 April 2001                                          [Page 19]

Internet Draft                 Alarm MIB                22 October 2000

                 _____________________________________________
                | nlmLogTable                                 |
                |---------------------------------------------|
                | nlmLogIndex |  alarm                        |
                |---------------------------------------------|
                |      1      | acmeWidgetTemperatureCritical |
                |      2      | bgpBackwardTransition         |
                |      3      | acmeWidgetTemperatureNormal   |
                |_____________________________________________|

9. Security Considerations

   There are no management objects defined in this MIB that have a MAX-
   ACCESS clause of read-write and/or read-create.  So, if this MIB is
   implemented correctly, then there is no risk that an intruder can
   alter or create any management objects of this MIB via direct SNMP
   SET operations.

10. Author's Address

   Sharon Chisholm
   Nortel Networks
   PO Box 3511, Station C
   Ottawa, Ontario, K1Y 4H7
   Canada

   Email: [email-masked]

11. References
        [1] Stewart, B,  Kavasseri, R, "Notification Log MIB,
            draft 17, October 2000
        [2] ITU Recommendation X.733, "Information Technology - Open
            Systems Interconnection - System Management: Alarm Reporting
            Function", 1992
        [3] ITU Recommendation X.736, "Information Technology - Open
            Systems Interconnection - System Management: Security Alarm
            Reporting Function", 1992

12. Full Copyright Statement

Copyright (C) The Internet Society (2000). All Rights Reserved.

This document and translations of it may be copied and furnished to
others, and derivative works that comment on or otherwise explain it or
assist in its implementation may be prepared, copied, published and
distributed, in whole or in part, without restriction of any kind,
provided that the above copyright notice and this paragraph are included

Expires 22 April 2001                                          [Page 20]

Internet Draft                 Alarm MIB                22 October 2000

on all such copies and derivative works.  However, this document itself
may not be modified in any way, such as by removing the copyright notice
or references to the Internet Society or other Internet organizations,
except as needed for the  purpose of developing Internet standards in
which case the procedures for copyrights defined in the Internet
Standards process must be followed, or as required to translate it into
languages other than English.

The limited permissions granted above are perpetual and will not be
revoked by the Internet Society or its successors or assigns.

This document and the information contained herein is provided on an "AS
IS" basis and THE INTERNET SOCIETY AND THE INTERNET ENGINEERING TASK
FORCE DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION HEREIN WILL NOT
INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE.

Expires 22 April 2001                                          [Page 21]